/**
 * Generated by Apache Royale Compiler from org/apache/royale/mdl/Dialog.as
 * org.apache.royale.mdl.Dialog
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.royale.mdl.Dialog');

goog.require('org.apache.royale.core.WrappedHTMLElement');
goog.require('org.apache.royale.events.Event');
goog.require('org.apache.royale.html.Group');
goog.require('org.apache.royale.html.util.DialogPolyfill');
goog.require('org.apache.royale.html.util.addElementToWrapper');
goog.require('org.apache.royale.core.IPopUp');



/**
 *  constructor.
 *
 *  @langversion 3.0
 *  @playerversion Flash 10.2
 *  @playerversion AIR 2.6
 *  @productversion Royale 0.8
 * @constructor
 * @extends {org.apache.royale.html.Group}
 * @implements {org.apache.royale.core.IPopUp}
 */
org.apache.royale.mdl.Dialog = function() {
  org.apache.royale.mdl.Dialog.base(this, 'constructor');
  this.typeNames = "mdl-dialog";
};
goog.inherits(org.apache.royale.mdl.Dialog, org.apache.royale.html.Group);


/**
 * @private
 * @type {HTMLDialogElement}
 */
org.apache.royale.mdl.Dialog.prototype.org_apache_royale_mdl_Dialog_dialog;


/**
 * @royaleignorecoercion org.apache.royale.core.WrappedHTMLElement
 * @royaleignorecoercion HTMLDialogElement
 * @protected
 * @override
 */
org.apache.royale.mdl.Dialog.prototype.createElement = function() {
  this.org_apache_royale_mdl_Dialog_dialog = org.apache.royale.html.util.addElementToWrapper(this, 'dialog');
  return this.element;
};


/**
 * @private
 * @type {boolean}
 */
org.apache.royale.mdl.Dialog.prototype.org_apache_royale_mdl_Dialog_lockDialogCreation = false;


/**
 *  This function make the dialog be added to document.body only once
 *
 *  @langversion 3.0
 *  @playerversion Flash 10.2
 *  @playerversion AIR 2.6
 *  @productversion Royale 0.8
 * @private
 */
org.apache.royale.mdl.Dialog.prototype.org_apache_royale_mdl_Dialog_prepareDialog = function() {
  if (!this.org_apache_royale_mdl_Dialog_lockDialogCreation) {
    this.org_apache_royale_mdl_Dialog_lockDialogCreation = true;
    var /** @type {HTMLElement} */ body = document.getElementsByTagName('body')[0];
    body.appendChild(this.element);
    this.addedToParent();
    if (!("showModal" in this.org_apache_royale_mdl_Dialog_dialog)) {
      org.apache.royale.html.util.DialogPolyfill.registerDialog(this.org_apache_royale_mdl_Dialog_dialog);
    }
  }
};


/**
 *  Displays the dialog element and makes it the top-most modal dialog.
 *
 *  @langversion 3.0
 *  @playerversion Flash 10.2
 *  @playerversion AIR 2.6
 *  @productversion Royale 0.8
 */
org.apache.royale.mdl.Dialog.prototype.showModal = function() {
  this.org_apache_royale_mdl_Dialog_prepareDialog();
  this.org_apache_royale_mdl_Dialog__open = true;
  this.org_apache_royale_mdl_Dialog_dialog.showModal();
};


/**
 *  Displays the dialog element.
 *
 *  Note: It seems MDL does not support non modal dialogs, since there's no examples
 *  and dialogs are always added to "document.body".
 *
 *  @langversion 3.0
 *  @playerversion Flash 10.2
 *  @playerversion AIR 2.6
 *  @productversion Royale 0.8
 */
org.apache.royale.mdl.Dialog.prototype.show = function() {
  this.org_apache_royale_mdl_Dialog_prepareDialog();
  this.org_apache_royale_mdl_Dialog__open = true;
  this.org_apache_royale_mdl_Dialog_dialog.show();
};


/**
 *  Closes the dialog element.
 *
 *  @langversion 3.0
 *  @playerversion Flash 10.2
 *  @playerversion AIR 2.6
 *  @productversion Royale 0.8
 */
org.apache.royale.mdl.Dialog.prototype.close = function() {
  this.org_apache_royale_mdl_Dialog__open = false;
  this.org_apache_royale_mdl_Dialog_dialog.close();
  this.dispatchEvent(new org.apache.royale.events.Event("close"));
};


/**
 * @private
 * @type {boolean}
 */
org.apache.royale.mdl.Dialog.prototype.org_apache_royale_mdl_Dialog__open;


/**
 * @nocollapse
 * @export
 * @type {boolean}
 */
org.apache.royale.mdl.Dialog.prototype.open;


org.apache.royale.mdl.Dialog.prototype.get__open = function() {
  return this.org_apache_royale_mdl_Dialog__open;
};


org.apache.royale.mdl.Dialog.prototype.get__visible = function() {
  return this.org_apache_royale_mdl_Dialog__open;
};


org.apache.royale.mdl.Dialog.prototype.set__visible = function(value) {
  if (value)
    this.show();
  else
    this.close();
};


Object.defineProperties(org.apache.royale.mdl.Dialog.prototype, /** @lends {org.apache.royale.mdl.Dialog.prototype} */ {
/**
 * @type {boolean}
 */
open: {
get: org.apache.royale.mdl.Dialog.prototype.get__open},
/**
 * @type {boolean}
 */
visible: {
get: org.apache.royale.mdl.Dialog.prototype.get__visible,
set: org.apache.royale.mdl.Dialog.prototype.set__visible}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.royale.mdl.Dialog.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'Dialog', qName: 'org.apache.royale.mdl.Dialog', kind: 'class' }], interfaces: [org.apache.royale.core.IPopUp] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.royale.mdl.Dialog.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    accessors: function () {
      return {
        'open': { type: 'Boolean', access: 'readonly', declaredBy: 'org.apache.royale.mdl.Dialog'},
        'visible': { type: 'Boolean', access: 'readwrite', declaredBy: 'org.apache.royale.mdl.Dialog'}
      };
    },
    methods: function () {
      return {
        'Dialog': { type: '', declaredBy: 'org.apache.royale.mdl.Dialog'},
        'showModal': { type: 'void', declaredBy: 'org.apache.royale.mdl.Dialog'},
        'show': { type: 'void', declaredBy: 'org.apache.royale.mdl.Dialog'},
        'close': { type: 'void', declaredBy: 'org.apache.royale.mdl.Dialog'}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
org.apache.royale.mdl.Dialog.prototype.ROYALE_COMPILE_FLAGS = 10;